%define BASE_VER 2.5
%define STABLE_VER 5
%define momorel 2

Summary: The Squid proxy caching server.
Name: squid
Version: %{BASE_VER}.%{STABLE_VER}
Release: %{momorel}m
License: GPL
Group: System Environment/Daemons
URL: http://www.squid-cache.org/
%NoSource 0 http://www.squid-cache.org/Versions/v2/%{BASE_VER}/squid-%{BASE_VER}.STABLE%{STABLE_VER}.tar.bz2 45ed1b1cd492e3f529085d09c3ffc1b8
Source1: http://www.squid-cache.org/Doc/FAQ/FAQ.sgml
Source2: squid.init
Source3: squid.logrotate
Source4: squid.sysconfig
Patch0: squid-2.5-config.patch
Patch1: squid-2.5.STABLE5-png.patch
Patch2: http://www.squid-cache.org/~wessels/patch/libntlmssp.c.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prereq: chkconfig logrotate shadow-utils
BuildRequires: gif2png, findutils, gdbm-devel >= 1.8.0
BuildPrereq: sgml-tools
Obsoletes: squid-novm

%description
Squid is a high-performance proxy caching server for Web clients,
supporting FTP, gopher, and HTTP data objects. Unlike traditional
caching software, Squid handles all requests in a single,
non-blocking, I/O-driven process. Squid keeps meta data and especially
hot objects cached in RAM, caches DNS lookups, supports non-blocking
DNS lookups, and implements negative caching of failed requests.

Squid consists of a main server program squid, a Domain Name System
lookup program (dnsserver), a program for retrieving FTP data
(ftpget), and some management and client tools.

Install squid if you need a proxy caching server.

%prep
%setup -q -n %{name}-%{BASE_VER}.STABLE%{STABLE_VER}
%patch0 -p1 -b .config
%patch1 -p1 -b .png
(cd helpers/ntlm_auth/SMB
%patch2 -p0 -b .orig
)
perl -p -i -e 's|\$\(datadir\)/icons|\$(datadir\)/squid/icons|' \
     src/Makefile.am icons/Makefile.am
find . -type f | xargs perl -p -i -e 's|/usr/local/bin/perl|/usr/bin/perl|'


%build
%configure \
   --exec_prefix=%{_prefix} \
   --bindir=%{_sbindir} \
   --libexecdir=%{_libdir}/squid \
   --datadir=%{_datadir}/squid \
   --localstatedir=/var \
   --sysconfdir=/etc/squid \
   --enable-poll \
   --enable-snmp \
   --enable-removal-policies="heap,lru" \
   --enable-storeio="aufs,coss,diskd,ufs,null" \
   --enable-delay-pools \
   --enable-linux-netfilter \
   --enable-htcp \
   --enable-carp \
   --with-pthreads \
   --enable-auth-modules="LDAP,NCSA,PAM,SMB,MSNT"
#   --enable-icmp

# Some versions of autoconf fail to detect sys/resource.h correctly;
# apparently because it generates a compiler warning.

if [ -e /usr/include/sys/resource.h ]; then
cat >>include/autoconf.h <<EOF
#ifndef HAVE_SYS_RESOURCE_H
#define HAVE_SYS_RESOURCE_H 1
#define HAVE_STRUCT_RUSAGE 1
#endif
EOF
fi

make

mkdir faq
cp $RPM_SOURCE_DIR/FAQ.sgml faq
cd faq 
sgml2html FAQ.sgml

%install
rm -rf %{buildroot}
%makeinstall  \
        sysconfdir=%{buildroot}%{_sysconfdir}/squid \
        localstatedir=%{buildroot}/var \
        bindir=%{buildroot}/usr/sbin \
        libexecdir=%{buildroot}%{_libdir}/squid \
	datadir=%{buildroot}%{_datadir}/squid
#install -m 4750 src/pinger %{buildroot}%{_libdir}/squid

# mv %{buildroot}/usr/sbin/*auth %{buildroot}%{_libdir}/squid

#cd errors
#rm -rf %{buildroot}%{_sysconfdir}/squid/errors
#mkdir -p %{buildroot}%{_libdir}/squid/errors
#for i in *; do
#   if [ -d $i ]; then
#       mkdir -p %{buildroot}%{_libdir}/squid/errors/$i
#       install -m 644 $i/* %{buildroot}%{_libdir}/squid/errors/$i
#   fi
#done
ln -s %{_datadir}/squid/errors/English %{buildroot}%{_sysconfdir}/squid/errors

mkdir -p %{buildroot}%{_initscriptdir}
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig

install -m 755 $RPM_SOURCE_DIR/squid.init %{buildroot}%{_initscriptdir}/squid
install -m 644 $RPM_SOURCE_DIR/squid.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/squid
install -m 644 $RPM_SOURCE_DIR/squid.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/squid
ln -sf %{_datadir}/squid/mib.txt %{buildroot}%{_sysconfdir}/squid/mib.txt

mkdir -p %{buildroot}/var/log/squid
mkdir -p %{buildroot}/var/cache/squid

find %{buildroot} -name "*.gif" | xargs gif2png -O
find %{buildroot} -name "*.gif" | xargs rm -f

rm -f %{buildroot}/etc/squid/msntauth.conf.default

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%dir %{_sysconfdir}/squid
%config(noreplace) %{_sysconfdir}/squid/squid.conf
%config(noreplace) %{_sysconfdir}/squid/mime.conf
%config(noreplace) %{_sysconfdir}/sysconfig/squid
%config(noreplace) %{_sysconfdir}/squid/msntauth.conf
%config(noreplace) %{_sysconfdir}/squid/squid.conf
%config %{_sysconfdir}/squid/mib.txt
%{_sysconfdir}/squid/squid.conf.default
%{_sysconfdir}/squid/mime.conf.default
%{_sysconfdir}/squid/errors
%{_libdir}/squid
%{_datadir}/squid
%{_sbindir}/squid
%{_sbindir}/squidclient
%{_sbindir}/RunCache
%{_sbindir}/RunAccel
%config %{_initscriptdir}/squid
%config %{_sysconfdir}/logrotate.d/squid
%doc faq/*
%doc CONTRIBUTORS COPYING COPYRIGHT CREDITS ChangeLog QUICKSTART
%doc README
%doc doc/*
%doc contrib/url-normalizer.pl contrib/rredir.* contrib/user-agents.pl
%attr(750,squid,squid) %dir /var/log/squid
%attr(750,squid,squid) %dir /var/cache/squid
%{_mandir}/man8/pam_auth.8*
%{_mandir}/man8/squid.8*
%{_mandir}/man8/squid_ldap_auth.8*

%pre
/usr/sbin/useradd -u 23 -d /var/cache/squid -r -s /dev/null squid >/dev/null 2>&1

for i in /var/{log/squid,cache/squid} ; do
	if [ -d $i ] ; then
		for adir in `find $i -maxdepth 0 \! -user squid`; do
			chown -R squid.squid $adir
		done
	fi
done

exit 0

%post
/sbin/chkconfig --add squid
if [ $1 = 0 ]; then
 case "$LANG" in
  bg*)
     DIR=Bulgarian
     ;;
  cs*)
     DIR=Czech
     ;;
  da*)
     DIR=Danish
     ;;
  nl*)
     DIR=Dutch
     ;;
  en*)
     DIR=English
     ;;
  ea*)
     DIR=Estonian
     ;;
  fi*)
     DIR=Finnish
     ;;
  fr*)
     DIR=French
     ;;
  de*)
     DIR=German
     ;;
  hu*)
     DIR=Hungarian
     ;;
  it*)
     DIR=Italian
     ;;
  ja*)
     DIR=Japanese
     ;;
  kr*)
     DIR=Korean
     ;;
  pl*)
     DIR=Polish
     ;;
  pt*)
     DIR=Portuguese
     ;;
  ro*)
     DIR=Romanian
     ;;
  ru*)
     DIR=Russian-koi8-r
     ;;
  sk*)
     DIR=Slovak
     ;;
  es*)
     DIR=Spanish
     ;;
  sv*)
     DIR=Swedish
     ;;
  zh*)
     DIR=Traditional_Chinese
     ;;
  tr*)
     DIR=Turkish
     ;;
  *)
     DIR=English
     ;;
 esac
 ln -snf %{_libdir}/squid/errors/$DIR %{_sysconfdir}/squid/errors
fi

%preun
if [ $1 = 0 ] ; then
	service squid stop >/dev/null 2>&1
	rm -f /var/log/squid/*
	/sbin/chkconfig --del squid
fi

%postun
if [ $1 = 0 ] ; then
	userdel squid
	service squid condrestart >/dev/null 2>&1
fi

%changelog
* Thu Jun 10 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.5.5-2m)
- [SECURITY FIX] apply 'libntlmssp.c.patch'

* Mon Mar 29 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (2.5.5-1m)
- update to 2.5-STABLE5
- this release includes security fix

* Sat Mar 27 2004 Toru Hoshina <t@momonga-linux.org>
- (2.5.4-4m)
- revised spec for rpm 4.2.

* Mon Dec 22 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.5.4-3m)
- accept gdbm-1.8.0 or newer

* Mon Nov 10 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.5.4-2m)
- rebuild against gdbm-1.8.0

* Thu Oct 30 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.5.4-1m)
- update to 2.5-STABLE4

* Thu Oct 30 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.5.3-2m)
- adapt the License: preamble for the Momonga Linux license
  expression unification policy (draft).

* Wed Jun 18 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.5-3.1m)
  update to 2.5-STABLE3

* Wed Mar 19 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.5-2.1m)
  update to 2.5-STABLE2

* Sun Mar  9 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.5-1m)
  update to 2.5-STABLE1

* Mon Feb 10 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (2.4-29m)
- rebuild against for gdbm

* Tue Nov 26 2002 Masahiro Takahata <takahata@momonga-linux.org>
- (2.4-28m)
- enable nullfs

* Mon Jul  8 2002 Kazuhiko <kazuhiko@fdiary.net>
- (2.4-27m)
- 2.4.STABLE7
- major security fixes

* Wed Mar 27 2002 Kazuhiko <kazuhiko@kondara.org>
- (2.4-24k)
- 2.4.STABLE6

* Wed Feb 27 2002 Masahiro Takahata <takahata@kondara.org>
- (2.4-22k)
- filename squid-2.4-perl-path.patch typo

* Wed Feb 27 2002 Masahiro Takahata <takahata@kondara.org>
- (2.4-20k)
- cleanup specfile
- add sysconfig/squid

* Sat Feb 23 2002 WATABE Toyokazu <toy2@kondara.org>
- (2.4-18k)
- update to 2.4-STABLE4 to fix security holes.
  http://www.squid-cache.org/Advisories/SQUID-2002_1.txt
- delete old patches.

* Sat Dec  1 2001 Toru Hoshina <t@kondara.org>
- (2.4-16k)
- No docs could be excutable :-p

* Thu Nov 22 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (2.4-14k)
- fix following patches (see http://www.squid-cache.org/Versions/v2/2.4/bugs/)
  squid-2.4.STABLE2-CONNECT_miss_access_core.patch
  squid-2.4.STABLE2-swap_meta.patch
  squid-2.4.STABLE2-ldap_auth_password_spaces.patch
  squid-2.4.STABLE2-ftp_create_directory.patch
  squid-2.4.STABLE2-statHistDump_prototype.patch
  squid-2.4.STABLE2-snmpwalk_coredump.patch
  squid-2.4.STABLE2-aufs_fd_leak.patch
- add "--enable-linux-netfilter"
- convert gif to png

* Tue Nov 13 2001 Shingo Akagaki <dora@kondara.org>
- (2.4-12k)
- nigittenu

* Tue Sep 11 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (2.4-10k)
- update to squid 2.4 STABLE2
- removed all official STABLE1 patches
- update FAQ.sgml from http://www.squid-cache.org/Doc/FAQ/FAQ.sgml

* Mon Apr 23 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (2.4-8k)
- merge official patches for squid-2.4.STABLE1, see
-  http://www.squid-cache.org/Versions/v2/2.4/bugs/
-  squid-2.4.stable1-diskd_fixed_path.patch
-  squid-2.4.stable1-htcp_assertion_fix.patch
- change cache_swap directory /var/spool/squid to /var/cache/squid

* Fri Apr 13 2001 Shingo Akagaki <dora@kondara.org>
- (2.4-6k)
- /etc/rc.d/init.d -> /etc/init.d

* Sun Apr  1 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (2.4-5k)
- merge official patches for squid-2.4.STABLE1, see
-  http://www.squid-cache.org/Versions/v2/2.4/bugs/
-  squid-2.4.stable1-wrong_sign_on_timestamp_check.patch
-  squid-2.4.stable1-high_cpu_with_peers.patch
-  squid-2.4.stable1-force_valid_blksize.patch
-  squid-2.4.stable1-kill_parent_on_child_sigkill.patch

* Sun Mar 25 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (2.4-3k)
- update to 2.4.STABLE1
- release-no to %{rel} and %{subrel}
- rework patches against squid-2.4.STABLE1
  (squid-2.1-make.patch to squid-2.4-make.patch,
   squid-2.3-config.patch to squid-2.4-config.patch,
   squid-2.3.stable4-perl-path-kondara.patch to squid-2.4-...)
- removed official patches for 2.3.STABLE4
- removed configure option "--enable-heap-replacement" (2.4 obsoletes)
- update FAQ.sgml 1.1.1.1 to 1.9
- enable "diskd"

* Sat Feb  3 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (2.3-7k)
- rebuild against rpm-3.0.5-39k

* Wed Nov 29 2000 Kenichi Matsubara <m@kondara.org>
- /etc/rc.d/init.d to %{_initscriptdir}

* Tue Aug 15 2000 Kenji Yamaguchi <yamk@sophiaworks.com>
- (2.3.stable4-1k)
- update to 2.3.stable4
- added 2.3.stable4 patches.
- deleted 2.3.stable1 patches.
- update FAQ.sgml from www.squid-cache.org.
- Kondarize. (SPEC)
- fixed scripts "#! /usr/local/bin/perl" to "#! /usr/bin/perl"
  [squid-2.3.stable4-perl-path-kondara.patch]

* Mon Feb 14 2000 Bill Nottingham <notting@redhat.com>
- Yet More Bugfix Patches

* Tue Feb  8 2000 Bill Nottingham <notting@redhat.com>
- add more bugfix patches
- --enable-heap-replacement

* Mon Jan 31 2000 Cristian Gafton <gafton@redhat.com>
- rebuild to fix dependencies

* Fri Jan 28 2000 Bill Nottingham <notting@redhat.com>
- grab some bugfix patches

* Mon Jan 10 2000 Bill Nottingham <notting@redhat.com>
- 2.3.STABLE1 (whee, another serial number)

* Tue Dec 21 1999 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix compliance with ftp RFCs
  (http://www.wu-ftpd.org/broken-clients.html)
- Work around a bug in some versions of autoconf
- BuildPrereq sgml-tools - we're using sgml2html

* Mon Oct 18 1999 Bill Nottingham <notting@redhat.com>
- add a couple of bugfix patches

* Wed Oct 13 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.STABLE5.
- update FAQ, fix URLs.

* Sat Sep 11 1999 Cristian Gafton <gafton@redhat.com>
- transform restart in reload and add restart to the init script

* Tue Aug 31 1999 Bill Nottingham <notting@redhat.com>
- add squid user as user 23.

* Mon Aug 16 1999 Bill Nottingham <notting@redhat.com>
- initscript munging
- fix conflict between logrotate & squid -k (#4562)

* Wed Jul 28 1999 Bill Nottingham <notting@redhat.com>
- put cachemgr.cgi back in /usr/lib/squid

* Wed Jul 14 1999 Bill Nottingham <notting@redhat.com>
- add webdav bugfix patch (#4027)

* Mon Jul 12 1999 Bill Nottingham <notting@redhat.com>
- fix path to config in squid.init (confuses linuxconf)

* Wed Jul  7 1999 Bill Nottingham <notting@redhat.com>
- 2.2.STABLE4

* Wed Jun 9 1999 Dale Lovelace <dale@redhat.com>
- logrotate changes
- errors from find when /var/spool/squid or
- /var/log/squid didn't exist

* Thu May 20 1999 Bill Nottingham <notting@redhat.com>
- 2.2.STABLE3

* Thu Apr 22 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.STABLE.2

* Sun Apr 18 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.STABLE1

* Thu Apr 15 1999 Bill Nottingham <notting@redhat.com>
- don't need to run groupdel on remove
- fix useradd

* Mon Apr 12 1999 Bill Nottingham <notting@redhat.com>
- fix effective_user (bug #2124)

* Mon Apr  5 1999 Bill Nottingham <notting@redhat.com>
- strip binaries

* Thu Apr  1 1999 Bill Nottingham <notting@redhat.com>
- duh. adduser does require a user name.
- add a serial number

* Tue Mar 30 1999 Bill Nottingham <notting@redhat.com>
- add an adduser in %pre, too

* Thu Mar 25 1999 Bill Nottingham <notting@redhat.com>
- oog. chkconfig must be in %preun, not %postun

* Wed Mar 24 1999 Bill Nottingham <notting@redhat.com>
- switch to using group squid
- turn off icmp (insecure)
- update to 2.2.DEVEL3
- build FAQ docs from source

* Tue Mar 23 1999 Bill Nottingham <notting@redhat.com>
- logrotate changes

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Wed Feb 10 1999 Bill Nottingham <notting@redhat.com>
- update to 2.2.PRE2

* Wed Dec 30 1998 Bill Nottingham <notting@redhat.com>
- cache & log dirs shouldn't be world readable
- remove preun script (leave logs & cache @ uninstall)

* Tue Dec 29 1998 Bill Nottingham <notting@redhat.com>
- fix initscript to get cache_dir correct

* Fri Dec 18 1998 Bill Nottingham <notting@redhat.com>
- update to 2.1.PATCH2
- merge in some changes from RHCN version

* Sat Oct 10 1998 Cristian Gafton <gafton@redhat.com>
- strip binaries
- version 1.1.22

* Sun May 10 1998 Cristian Gafton <gafton@redhat.com>
- don't make packages conflict with each other...

* Sat May 02 1998 Cristian Gafton <gafton@redhat.com>
- added a proxy auth patch from Alex deVries <adevries@engsoc.carleton.ca>
- fixed initscripts

* Thu Apr 09 1998 Cristian Gafton <gafton@redhat.com>
- rebuilt for Manhattan

* Fri Mar 20 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 1.1.21/1.NOVM.21

* Mon Mar 02 1998 Cristian Gafton <gafton@redhat.com>
- updated the init script to use reconfigure option to restart squid instead
  of shutdown/restart (both safer and quicker)

* Sat Feb 07 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 1.1.20
- added the NOVM package and tryied to reduce the mess in the spec file

* Wed Jan 7 1998 Cristian Gafton <gafton@redhat.com>
- first build against glibc
- patched out the use of setresuid(), which is available only on kernels
  2.1.44 and later

